function c=ContrInd(A,B)

% Given a nxn matrix A and a nxm matrix B ,
% this function returns the controllability
% indices of the controllable pair (A,B)
% by computing the left Wiener-Hopf 
% factorization indices of P(s) of the
% representation (s*I-A)^-1*B=N(s)*P(s)^-1

n=length(A);
if rank(ctrb(A,B))==n
    g=inv(s*eye(n)-A)*B
    d=coprime(rdf(g))
    c=lWHf(den(d));
else
    display('the pair (A,B) should be controllable!')
end    