function o=ObservInd(A,C)

% Given a nxn matrix A and a pxn matrix C ,
% this function returns the observability
% indices of the observable pair (A,C)
% by computing the right Wiener-Hopf 
% factorization indices of P(s) of the
% representation C*(s*I-A)^-1=P(s)^-1*N(s)

n=length(A);
if rank(obsv(A,C))==n
    g=C*inv(s*eye(n)-A)
    d=coprime(ldf(g))
    o=rWHf(den(d));
else
    display('the pair (A,C) should be observable!')
end    