function  [S,U,V,Ui,Vi]=finiteSmithMcMillan(Nr,Dr)

% Given the numerator and the denominator
% of a mxn rational matrix
% this function returns its finite
% Smith-McMillan form S : S = U(s)*T(s)*V(s),
% the matrices U(s),V(s) and their 
% inverse matrices Ui = U^(-1) and Vi = V^(-1)

n=size(Nr);
t=Nr./Dr
p=plcm(Dr);
f=plcm(p);
N=f*t;
[s,u,v,ui,vi]=smith(N)
S=coprime(s/f)
U=u
V=v
Ui=ui
Vi=vi