function lc=localContInd(A,B)

% Given a nxn matrix A and a nxm matrix B ,
% this function returns the local
% controllability indices of the 
% controllable pair (A,B)
% by computing the local Wiener-Hopf 
% factorization indices of P(s) of the
% representation (s*I-A)^-1*B=N(s)*P(s)^-1

y=length(A);
if rank(ctrb(A,B))==y
    g=inv(s*eye(y)-A)*B
    d=coprime(rdf(g))
    lc=localWH(den(d));
else
    display('the pair (A,B) should be controllable!')
end    