function lk=localWH(P)

% Given a square ponynomial matrix P , 
% this function returns its local
% Wiener-Hopf factorization indices
% with respect to a monic irreducible
% polynomial . P is written as A*B

x=size(P);
if x(1)~=x(2)
    display('matrix should be square!')
end
[S,U,V,UI,VI]=smith(P);
S=sym(S);
g=pgcd(S);
c=pgcd(g);
d=s*zeros(1,x(2));
if c==1
    sn=sym2poly(S(x(1),x(2)));
    r=roots(sn);
    m=length(r);
    for i=1:m
        if isreal(r(i))==1
            for j=1:x(2)
                [v,n]=charact(S(j,j),r(i));
                d(j)=(s-r(i))^n;
            end
            a=diag(d,0);
            b=inv(a)*S;
            A=UI*a
            B=b*VI
            display('local Wiener-Hopf indices with respect to')
            s-r(i)
            lk=lWHf(A)
        end
    end
    for i=1:m-1
        if isreal(r(i))~=1
            if r(i)==conj(r(i+1))
               i=i+1;
            end
            for j=1:x(2)
                [v,n]=charact(S(j,j),r(i)) ;        
                d(j)=((s-r(i))*(s-conj(r(i))))^n;
            end
            a=diag(d,0);
            b=inv(a)*S;
            A=UI*a
            B=b*VI
            display('local Wiener-Hopf indices with respect to')
            (s-r(i))*(s-conj(r(i)))
            lk=lWHf(A)
        end
    end           
else
    w=roots(c);
    q=length(w);
    for i=1:q
        if isreal(w(i))==1
            for j=1:x(2)
                [v,n]=charact(S(j,j),w(i));
                d(j)=(s-w(i))^n;
            end
            a=diag(d,0);
            b=inv(a)*S;
            A=UI*a
            B=b*VI
            display('local Wiener-Hopf indices with respect to')
            s-w(i)
            lk=lWHf(A)
        end
    end
    for i=1:q-1
        if isreal(w(i))~=1
            if w(i)==conj(w(i+1))
               i=i+1;
            end
            for j=1:x(2)
                [v,n]=charact(S(j,j),w(i)) ;        
                d(j)=((s-w(i))*(s-conj(w(i))))^n;
            end
            a=diag(d,0);
            b=inv(a)*S;
            A=UI*a
            B=b*VI
            display('local Wiener-Hopf indices with respect to')
            (s-w(i))*(s-conj(w(i)))
            lk=lWHf(A)
        end
    end           
end