function [l,Ur,Dr,Br]=rWH(t)

% Given a mxn polynomial matrix t ,  
% this function computes the right Wiener-Hopf
% factorization T(s)=U(s)D(s)B(s), where  
% U(s) is a unimodular matrix ,
% D(s) is a diagonal matrix and 
% B(s) is a biproper  matrix , 
% and its corresponding indices l=[l1,l2,...,lr]
% r=min{m,n}.

a=transpose(t);
[k,B,D,U]=lWHf(a);
l=k;
Ur=transpose(U);
Dr=transpose(D);
Br=transpose(B);
